summaryrefslogtreecommitdiffstats
path: root/kconfigpp
diff options
context:
space:
mode:
authorP. J. McDermott <pj@pehjota.net>2014-11-24 12:33:20 (EST)
committer P. J. McDermott <pj@pehjota.net>2014-11-24 12:33:20 (EST)
commit8ed1b04d2ac1e200a33338a00f35176cefdc8e7d (patch)
tree3ea5fe3010d485535361333564666bca67fa2a76 /kconfigpp
parenta3a6c44e6d763ab8b2f49f8f97013f8d5e5e2424 (diff)
kconfigpp: Initial implementation
Diffstat (limited to 'kconfigpp')
-rw-r--r--kconfigpp/kconfigpp.sh54
1 files changed, 54 insertions, 0 deletions
diff --git a/kconfigpp/kconfigpp.sh b/kconfigpp/kconfigpp.sh
new file mode 100644
index 0000000..90b03f1
--- /dev/null
+++ b/kconfigpp/kconfigpp.sh
@@ -0,0 +1,54 @@
+#!/bin/sh
+#
+# Kconfig preprocessor
+#
+# Copyright (C) 2014 Patrick "P. J." McDermott
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License along
+# with this program; if not, write to the Free Software Foundation, Inc.,
+# 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+set -u
+
+main()
+{
+ if [ ${#} -ne 1 ]; then
+ usage >&2
+ exit 1
+ fi
+
+ parse "${1}"
+}
+
+usage()
+{
+ printf 'Usage: %s <kconfig-file>\n' "${0}"
+}
+
+parse()
+{
+ local file="${1}"
+ local line=
+
+ while IFS='' read line; do
+ if [ "x${line}" != "x${line#source}" ]; then
+ line="$(printf '%s' "${line}" | \
+ sed 's/^source[ \t][ \t]*"*\([^"]*\).*$/\1/')"
+ parse "${line}"
+ else
+ printf '%s\n' "${line}"
+ fi
+ done <"${file}"
+}
+
+main "${@}"